/* avgini.c
   GAMEEXE.INIāABGMDirectSoundł͂Ȃ
   CDĐݒɂ
   ł_inmm.ini쐬

   01/03/13 initial
   01/03/23 WAVJȂƂɒ~/Ďs/
            KOE_DOUBLE_PAC0ɂ
   03/12/08 RealLiveΉ
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <io.h>
#include <stdarg.h>
#include <assert.h>

#define PROGNAME	"avgini.exe"
#define STRPAT		"\"%[^\"]\""
#define DSTRACKPAT	"#DSTRACK = %d - %d - %d = "STRPAT" = "STRPAT
#define SUCCESS		1
#define FAIL		0

enum System { UNKNOWN, AVG32, REALLIVE };

#pragma pack(push, 1)
struct WaveHeader {	/* Ȃ肢 */
	DWORD riff;
	DWORD riffsize;
	DWORD wave;
	DWORD fmt;
	DWORD fmtsize;
	WAVEFORMAT wf;
	WORD bits_per_sample;
	DWORD data;
	DWORD datasize;
};

struct NwaHeader {
	WORD channels;
	WORD bps; /* bits per sample */
	DWORD freq; /* samples per second */
	DWORD complevel; /* compression level */
	DWORD dummy; /* ? : 0x00 */
	DWORD blocks; /* block count */
	DWORD datasize; /* all data size */
	DWORD compdatasize; /* compressed data size */
	DWORD samplecount; /* all samples */
	DWORD blocksize; /* samples per block */
	DWORD restsize; /* samples of the last block */
	DWORD dummy2; /* ? : 0x89 */
};
#pragma pack(pop)

struct BGMInfo {
	int rate;	/* 1bDSTRACK̐ */
	int total;	/* rate * Ȃ̒(b) */
};

int msgboxf(UINT style, const char* fmt, va_list arglist)
{
	char buf[1024];
	vsprintf(buf, fmt, arglist);
	return MessageBox(NULL, buf, PROGNAME, style);
}

void showerror(const char* fmt, ...)
{
	va_list argptr;

	va_start(argptr, fmt);
	msgboxf(MB_OK | MB_ICONSTOP, fmt, argptr);
	va_end(argptr);
}

int abort_retry_ignore(const char* fmt, ...)
{
	int r;
	va_list argptr;

	va_start(argptr, fmt);
	r = msgboxf(MB_ABORTRETRYIGNORE | MB_ICONSTOP, fmt, argptr);
	va_end(argptr);
	return r;
}

/* t@C̑݌ */
int exist(const char *fname)
{
	if (access(fname, 0) == -1 && errno == ENOENT) {
		errno = 0;
		return 0;
	}
	return 1;
}

enum System check_system(int argc, char **argv)
{
	int i;
	for (i = 1; i < argc; i++) {
		if (strcmp(argv[i], "--avg32") == 0)
			return AVG32;
		if (strcmp(argv[i], "--reallive") == 0)
			return REALLIVE;
	}
	if (exist("REALLIVE.EXE"))
		return REALLIVE;
	if (exist("AVG3216M.EXE") || exist("AVG3216D.EXE") ||
		exist("AVG3217M.EXE") || exist("AVG3217D.EXE"))
		return AVG32;
	return UNKNOWN;
}

/* t@Cgq.org[]Ƀl[ */
/* VO or NULL(s) Ԃ      */
char *rename_orig(const char *fname)
{
	char *newname, *dot;
	int i;
	
	newname = malloc(strlen(fname) + 10);
	strcpy(newname, fname);

	/* gq̈ʒudotɂ */
	dot = strrchr(newname, '.');
	if (dot != NULL && strchr(dot, '\\') != NULL)
		dot = NULL;
	if (dot == NULL)
		dot = newname + strlen(newname);

	/* .org n߂ .org1, .org2, ..Ǝ */
	i = 0;
	strcpy(dot, ".org");
	while (exist(newname))
		sprintf(dot, ".org%d", ++i);

	if (rename(fname, newname) == -1) {
		showerror("%s%sɃl[ł܂: %s",
				  fname, newname, strerror(errno));
		return NULL;
	}
	return newname;
}

/* bkupnameɃl[t@Cfnameɖ߂ */
void restore(const char* fname, const char* bkupname)
{
	if (remove(fname) == -1 && errno != ENOENT)
		showerror("%s̍폜Ɏs܂: %s", fname, strerror(errno));
	
	if (bkupname != NULL) {
		if (rename(bkupname, fname) == -1) {
			showerror("%s%sɃl[ł܂: %s",
					  bkupname, fname, strerror(errno));
		}
	}
}

/* GAMEEXE.INI烌WXgL[𒲂ׁÃWXgBGMtH_𓾂 */
/* BGMtH_ or NULL(s) Ԃ */
char *getbgmfolder(FILE *fp)
{
	HKEY hkey;
	char buf[1024], str[256], key[256], *folder;
	DWORD size = 256;
	LONG r;
	const char *msg = "BGMtH_̎擾Ɏs:\n";
	
	while (fgets(buf, sizeof buf, fp) != NULL) {
		if (sscanf(buf, "#REGNAME = "STRPAT, str) == 0)
			continue;
		
		sprintf(key, "Software\\%s", str);
		r = RegOpenKeyEx(HKEY_CURRENT_USER, key, 0, KEY_QUERY_VALUE, &hkey);
		if (r != ERROR_SUCCESS) {
			showerror("%sWXg HKEY_CURRENT_USER\\%s J܂B",
					  msg, key);
			return NULL;
		}
		
		folder = malloc(size);
		r = RegQueryValueEx(hkey, "BGM_FOLDER", 0, NULL, folder, &size);
		RegCloseKey(hkey);
		if (r != ERROR_SUCCESS) {
			showerror("%sHKEY_CURRENT_USER\\%s\\BGM_FOLDER ǂ߂܂B",
					  msg, key);
			return NULL;
		}
		return folder;
	}
	showerror("%sGAMEEXE.INIɍ#REGNAME܂B", msg);
	return NULL;
}

int getnwainfo(const char *fname, struct BGMInfo *info, enum System system)
{
	FILE *fp;
	struct NwaHeader nh;

	fp = fopen(fname, "rb");
	if (fp == NULL)
		return FAIL;
	fread(&nh, sizeof nh, 1, fp);
	fclose(fp);

	if (nh.datasize != nh.samplecount * nh.bps / 8 ||
		nh.samplecount != (nh.blocks-1) * nh.blocksize + nh.restsize)
	{
		showerror("%s͕sȁA܂͖Ή̌`nwat@CłB",
				  fname);
		return FAIL;
	}

	assert(system == REALLIVE);
	info->rate = nh.freq;
	info->total = nh.samplecount / nh.channels;
	return SUCCESS;
}

int getwaveinfo(const char *fname, struct BGMInfo *info, enum System system)
{
	struct WaveHeader wh;
	FILE *fp;

	while ((fp = fopen(fname, "rb")) == NULL) {
		switch (abort_retry_ignore("%s̃I[vɎs܂B", fname)) {
		case IDABORT:
			return FAIL;
		case IDIGNORE:
			return SUCCESS;
		}
	}
	fread(&wh, sizeof wh, 1, fp);
	fclose(fp);

	if (wh.fmt  != mmioFOURCC('f','m','t',' ') ||
		wh.data != mmioFOURCC('d','a','t','a') ||
		wh.wf.wFormatTag != WAVE_FORMAT_PCM)
	{
		showerror("%s͖kWAVE`ł͂܂B", fname);
		return FAIL;
	}
	if (system == AVG32) {
		info->rate = wh.wf.nAvgBytesPerSec;
		info->total = wh.datasize;
	}
	else {
		info->rate = wh.wf.nSamplesPerSec;
		info->total = wh.datasize / wh.wf.nBlockAlign;
	}
	return SUCCESS;
}

int getbgminfo(const char* dir, const char* name,
			   struct BGMInfo *info, enum System system)
{
	static int default_samples_per_sec = 22050;

	char pathname[256];
	int r = FAIL;

	info->rate = default_samples_per_sec;
	if (system == AVG32)
		info->rate *= 2 * 2;
	info->total = info->rate * 60;

	if (system == REALLIVE) {
		sprintf(pathname, "%s\\%s.nwa", dir, name);
		r = getnwainfo(pathname, info, system);
	}
	if (r == FAIL) {
		sprintf(pathname, "%s\\%s.wav", dir, name);
		r = getwaveinfo(pathname, info, system);
	}

	default_samples_per_sec = info->rate;
	if (system == AVG32)
		default_samples_per_sec /= 2 * 2;
	return r;
}

/* DSTRACK̐MSFiAbAt[j`ɕϊďo */
void puttime(int count, int rate, int track, FILE* fp)
{
	int m, s, f;
	m = count / (rate * 60);
	s = count / rate % 60;
	f = count * 75 / rate % 75;
	fprintf(fp, "%02d:%02d:%02d:%02d", track, m, s, f);
}

int put_cdtrack(FILE *fp, int start, int end, int repeat,
				const char *fname, const char *name,
				int track, const char *bgmfolder, enum System system)
{
	struct BGMInfo info;

	fprintf(fp, "#CDTRACK = ");
	if (system == REALLIVE && start == 0 && end == 99999999 && repeat == 0)
		fprintf(fp, "%02d:00:00:00 - 00:00:00:00 - 00:00:00:00", track);
	else {
		if (getbgminfo(bgmfolder, fname, &info, system) == FAIL)
			return FAIL;

		puttime(start, info.rate, track, fp);
		fprintf(fp, " - ");

		if (end != 99999999)
			puttime(end, info.rate, track, fp);
		else if (system == REALLIVE)
			fprintf(fp, "00:00:00:00");
		else
			puttime(info.total, info.rate, track, fp);

		fprintf(fp, " - ");
		puttime(repeat, info.rate, track, fp);
	}
	fprintf(fp, " = \"%s\"\n", name);
	return SUCCESS;
}

/* 又 */
int conv(FILE *geini_r, FILE *geini_w, FILE *inmmini, enum System system)
{
	char *bgmfolder;
	char buf[1024], str[256];
	char fname[64], name[64];
	int n, start, end, repeat;
	int track = 2;

	bgmfolder = getbgmfolder(geini_r);
	if (bgmfolder == NULL)
		bgmfolder = "BGM";
	fseek(geini_r, 0, SEEK_SET);

	/* 1sǂłāAKvȂΒus */
	while (fgets(buf, sizeof buf, geini_r) != NULL) {
		if (system == AVG32 &&
			sscanf(buf, "#MUSIC_TYPE = %d", &n) == 1)
			fprintf(geini_w, "#MUSIC_TYPE = 003\n");
		else if (system == AVG32 &&
				 sscanf(buf, "#KOE_DOUBLE_PAC = %d", &n) == 1)
			fprintf(geini_w, "#KOE_DOUBLE_PAC = 000\n");
		else if (system == REALLIVE &&
				 sscanf(buf, "#SYSCOM.011 = N : "STRPAT, str) == 1)
			fprintf(geini_w, "#SYSCOM.011 = U:\"%s\"\n", str);
		else if (system == REALLIVE &&
				 sscanf(buf, "#BGM_MODE = %d", &n) == 1)
			fprintf(geini_w, "#BGM_MODE = 1\n");
		else if (system == REALLIVE &&
				 sscanf(buf, "#CDDA_%3s_SETUP_NEED = %d", str, &n) == 2)
			fprintf(geini_w, "#CDDA_%s_SETUP_NEED = 0\n", str);
		else if (sscanf(buf, DSTRACKPAT, &start, &end, &repeat, fname, name)
				 == 5)
		{
			if (system == REALLIVE)
				fprintf(geini_w, buf);	/* #DSTRACK=̍sc */
			if (put_cdtrack(geini_w, start, end, repeat, fname, name,
							track, bgmfolder, system) == FAIL)
				return FAIL;
			fprintf(inmmini, "%s\\%s.wav\n", bgmfolder, fname);
			track++;
		}
		else
			fprintf(geini_w, buf);
	}
	return SUCCESS;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   PSTR szCmdLine, int nCmdShow)
{
	char *geini_org;
	char *inmmini_org = NULL;
	FILE *geini_r = NULL;
	FILE *geini_w = NULL;
	FILE *inmmini = NULL;
	enum System system;

	if (!exist("GAMEEXE.INI")) {
		showerror("GAMEEXE.INItH_ŎsĂB");
		return 1;
	}
	system = check_system(__argc, __argv);
	if (system == UNKNOWN) {
		showerror(
			"VXeł܂B\n"
			"AVG321XX.EXEREALLIVE.EXÊtH_Ŏs邩A"
			"--avg32 ܂ --reallive IvVĎsĂB");
		return 1;
	}

	geini_org = rename_orig("GAMEEXE.INI");
	if (geini_org == NULL)
		goto error;

	geini_r = fopen(geini_org, "rt");
	if (geini_r == NULL) {
		showerror("IWiGAMEEXE.INĨI[vɎs܂B");
		goto error;
	}

	geini_w = fopen("GAMEEXE.INI", "wt");
	if (geini_w == NULL) {
		showerror("GAMEEXE.INI̐VK쐬Ɏs܂B");
		goto error;
	}

	if (exist("_inmm.ini")) {
		inmmini_org = rename_orig("_inmm.ini");
		if (inmmini_org == NULL)
			goto error;
	}

	inmmini = fopen("_inmm.ini", "wt");
	if (inmmini == NULL) {
		showerror("_inmm.ini̐VK쐬Ɏs܂B");
		goto error;
	}

	if (conv(geini_r, geini_w, inmmini, system) == FAIL)
		goto error;

	MessageBox(NULL, "܂B", PROGNAME, MB_OK | MB_ICONINFORMATION);
	return 0;
	
 error:
	if (inmmini != NULL)
		fclose(inmmini);
	restore("_inmm.ini", inmmini_org);
	
	if (geini_r != NULL)
		fclose(geini_r);
	if (geini_w != NULL)
		fclose(geini_w);
	restore("GAMEEXE.INI", geini_org);
	return 1;
}
